#!/usr/bin/python

import os
import sys
import tty, termios

print "This script will copy the contents of your LEGO Education WeDo 1.2 disc to your hard disk, make necessary adjustments to the installer for Mac OS X 10.7 and later, and then initiate the LEGO Education WeDo 1.2 installer. Please insert the LEGO Education WeDo 1.2 disc before you continue. Would you like to continue? (Y/N)"

fd = sys.stdin.fileno()
old_settings = termios.tcgetattr(fd)
try:
	tty.setraw(fd)
	ch = sys.stdin.read( 1 )
finally:
	termios.tcsetattr(fd, termios.TCSADRAIN, old_settings)

if not ch.upper()=="Y":
	print "Installation aborted"
	sys.exit(0)

WeDoCDInsterted = False

folderNamesUnderVolumes = os.listdir('/Volumes')

for name in folderNamesUnderVolumes:
	if name == "WeDo 1.2":
		WeDoCDInsterted = True

if not WeDoCDInsterted:
	print "The LEGO Education WeDo 1.2 disc could not be found. Please insert the LEGO Education WeDo 1.2 disc and try again."
	sys.exit(0)

WeDoTempDir = "/tmp/WeDo12Temp"

if os.path.exists(WeDoTempDir):
	os.system("rm -rf %s" % WeDoTempDir)

print "Please wait while the contents of the LEGO Education WeDo 1.2 disc are copied to your hard disk..."

copyCmd = "cp -R \"/Volumes/WeDo 1.2/\"* %s" % WeDoTempDir

try:
	os.makedirs(WeDoTempDir)
except:
	print "Error creating %s" % WeDoTempDir

os.system(copyCmd)

for root, dirs, files in os.walk(WeDoTempDir):	
	for file in files:
		if file == "Info.plist":
			filepath = os.path.join(root,file)
			readhandler = open(filepath)
			lines=readhandler.readlines()
			contents=''
			for line in lines:
				contents += line	
			readhandler.close()
			
			contents = contents.replace("<string>hw.machine</string>","<string>machdep.cpu.vendor</string>")
			contents = contents.replace("<string>i386</string>","<string>GenuineIntel</string>")
			os.system("chmod 777 \"%s\"" % filepath)
			writehandler = open(filepath,'w')
			writehandler.write(contents)
			writehandler.close()
			os.system("chmod 555 \"%s\"" % filepath)


LaunchCmd = "open -a \"%s/Install.app\"" % WeDoTempDir
os.system(LaunchCmd)

print "The script has completed, please proceed with the WeDo installer dialogs to install LEGO Education WeDo 1.2 on your machine"

